
Rect ActiveTemplateMatching(Mat frame, Rect firstROI) {

	static int activeTemplateFrameCount = 0;
	static Mat reference;
	static Rect activeTemplateROI;


	Mat queryImage,result;


	activeTemplateFrameCount++;
	//cout << "Frame #"<<activeTemplateFrameCount<<endl;

	frame.copyTo(queryImage);
	//cvtColor(frame, queryImage, CV_RGB2GRAY);
		
	//> First template reference
	if (activeTemplateFrameCount == 1) {
		queryImage(firstROI).copyTo(reference);
		activeTemplateROI = firstROI;
		return activeTemplateROI;

	} else if (true) { //> Setting a ROI to search the next frame

		//cout << "Search within: "<<activeTemplateROI<<endl;

		activeTemplateROI = rectSum2(activeTemplateROI,40);
		rectInsideImage(queryImage,activeTemplateROI);
		
		queryImage = queryImage(activeTemplateROI);
		drawRect(frame,activeTemplateROI,Scalar(0,0,255));	//> Draw red search area
	}

	showImage(reference,"Current Template");

	matchTemplate( queryImage, reference, result, CV_TM_CCOEFF_NORMED );
	//normalize( result, result, 0, 1, NORM_MINMAX, -1, Mat() );

	//showImage(result,"Template Matching result");

	//> Localizing the best match with minMaxLoc
	double minVal, maxVal; 
	Point minLoc, maxLoc, matchLoc;

	minMaxLoc( result, &minVal, &maxVal, &minLoc, &maxLoc, Mat() );
	matchLoc = maxLoc;
	//cout << "Value: "<< maxVal << endl;

	Point topLeft = matchLoc;
	matchLoc = Point(matchLoc.x+activeTemplateROI.x,matchLoc.y+activeTemplateROI.y);
	activeTemplateROI = Rect(matchLoc.x,matchLoc.y,firstROI.width,firstROI.height);
	//cout << "Object ROI: <" << activeTemplateROI << endl;
		

	drawRect(frame,activeTemplateROI);	//> Draw bounding box
	//showImage(frame,"Tracker (template)");
		
	//> Updating template
	if (activeTemplateFrameCount%6==0 /*maxVal > 0.55f*/) {
		Rect r(topLeft.x, topLeft.y, firstROI.width, firstROI.height);
		if (rectInsideImageCheck(queryImage, r)) {
			//cout << "Updating Reference..." << endl;
			queryImage(r).copyTo(reference);
			//showImage(reference, "Current Template");
		}
	}
	

	
	return activeTemplateROI;

}